blob: 8b7d5f11d46148bd862a510e59287abcf8752c96 [file] [log] [blame]
Ove Kaaven2043ba01999-04-18 13:16:29 +00001#!/bin/bash
2# WINE Installation script
Ove Kaaven2c767522000-10-29 18:02:53 +00003# Can do almost everything from compiling to configuring...
Ove Kaaven2043ba01999-04-18 13:16:29 +00004
5# Mar 31 1999 - Ove Kåven
6# First version
Ove Kaavenb822b842000-02-25 20:51:09 +00007# Dec 9 1999 - Ove Kåven
8# require Xpm
9# Feb 25 2000 - Ove Kåven
10# auto-add /usr/local/lib to /etc/ld.so.conf
Ove Kaavence2b7242000-03-04 19:13:52 +000011# Mar 2 2000 - Ove Kåven
12# source rather than grep config.cache
13# use sourced config.cache to start ldconfig
14# reconfigure if config.cache doesn't exist
Ove Kaavene1858882000-04-08 20:20:21 +000015# Mar 30 2000 - Ove Kåven
16# autoconfigure no-windows installs
17# do not install registry on real-windows installs
18# some support for binary package installs
19# set and tell user about LD_LIBRARY_PATH if necessary
20# set EXTRA_LD_LIBRARY_PATH in wine.conf
Ove Kaavenb5d37ec2000-04-15 20:37:14 +000021# Apr 9 2000 - Ove Kåven
22# make root's registry global (system-default)
Ove Kaavenf561aad2000-05-09 22:32:42 +000023# May 9 2000 - Ove Kåven
24# use ttydrv when running regapi, so we don't have to run from X
25# change debugger path in registry
Ove Kaaven2c767522000-10-29 18:02:53 +000026# Oct 29 2000 - Ove Kåven
27# added --enable-opengl to default confargs
28# added conf_question, conf_yesno_answer, and conf_string_answer functions
29# added DEFCAT variable
Ove Kaaven6e143b32000-10-31 00:59:01 +000030# (later that day...)
31# added conf_reset_question function
32# added file existence checks to the registry copying
33# fixed problem with no-windows directory creation
34# some text reformatting from Eric Maryniak
Ove Kaaven2043ba01999-04-18 13:16:29 +000035
Ove Kaavenf561aad2000-05-09 22:32:42 +000036#--- defaults (change these if you are a packager)
Ove Kaaven2c767522000-10-29 18:02:53 +000037CONFARGS=--enable-opengl # configure args, e.g. --prefix=/usr --sysconfdir=/etc
Ove Kaavene1858882000-04-08 20:20:21 +000038prefix=/usr/local # installation prefix
Ove Kaavenb5d37ec2000-04-15 20:37:14 +000039sysconfdir=$prefix/etc # where wine.conf and global registry is supposed to be
Ove Kaavenf561aad2000-05-09 22:32:42 +000040bindir=$prefix/bin # where winelib apps will be (or is) installed
Ove Kaavenb5d37ec2000-04-15 20:37:14 +000041libdir=$prefix/lib # where libwine.so will be (or is) installed
42exdir=documentation/samples # where the example system.ini resides
Ove Kaavene1858882000-04-08 20:20:21 +000043CONF=$sysconfdir/wine.conf # default path of the wine.conf
44BINDIST=no # whether called from a binary package config script
45DOCONF=auto # whether to autogenerate wine.conf
46DOWCHK=auto # whether to autoconfigure existing-windows installation
47DOWINE=auto # whether to autoconfigure no-windows installation
48DOREG=auto # whether to install default registry
Ove Kaavenb5d37ec2000-04-15 20:37:14 +000049SYSREG=yes # whether to make root's registry global (system-default)
Ove Kaavenf561aad2000-05-09 22:32:42 +000050
51# "make install" still installs the dlls into $libdir, but this may change in the future
52# (DLLPATH should point to them if/when they are not in standard ld.so paths)
53DLLPATH=$libdir/wine # default path of the dll .so files (except libwine.so)
54
55# having the Wine debugger launched automatically will be a plus for us
56DEBUGGER=$bindir/winedbg # the (installed) path of winedbg
57HDEBUGGER=debugger/winedbg # the (non-installed) path of winedbg
58
59# this is only for existing-windows installs
Ove Kaavenb5d37ec2000-04-15 20:37:14 +000060WINECONF=tools/wineconf # the path of wineconf perl script
Ove Kaavenf561aad2000-05-09 22:32:42 +000061
62# this is only for no-windows installs
Ove Kaavene1858882000-04-08 20:20:21 +000063WINEINI=wine.ini # the path of default wine.ini (also used by wineconf)
64WININI=/dev/null # the path of default win.ini
Ove Kaavenb5d37ec2000-04-15 20:37:14 +000065SYSTEMINI=$exdir/system.ini # the path of default system.ini
Ove Kaavene1858882000-04-08 20:20:21 +000066REGAPI=programs/regapi/regapi # the path of regapi winelib application
67DEFREG=winedefault.reg # the path of the registry file to be fed to regapi
Ove Kaavenb5d37ec2000-04-15 20:37:14 +000068# CROOT=/var/wine # the path of the fake Drive C (asks user if not set)
Ove Kaaven2c767522000-10-29 18:02:53 +000069DEFCAT=cat # program to cat $DEFREG with (some packages need zcat)
Ove Kaavenf561aad2000-05-09 22:32:42 +000070#--- end of defaults
71
72# temporary files used by the installer
73TMPCONF=/tmp/wineinstall.conf
74TMPREG=/tmp/wineinstall.reg
Ove Kaaven2043ba01999-04-18 13:16:29 +000075
Ove Kaaven2c767522000-10-29 18:02:53 +000076# functions
77
78function conf_question {
79 # parameters: $1 = importance, $2 = question-id, $3+ = message lines
80 # the first two parameters can be used by e.g. debconf in debian packages
81 # but here we just print the message
82 shift 2
83 echo
84 local LINE="$1"
85 while shift
86 do {
87 echo "$LINE"
88 LINE="$1"
89 }
90 done
91}
92
Ove Kaaven6e143b32000-10-31 00:59:01 +000093function conf_reset_question {
94 # parameters: $1 = question-id
95 # this is used to flush any cached answers and "already-displayed" flags
96 shift # dummy command
97}
98
Ove Kaaven2c767522000-10-29 18:02:53 +000099function conf_yesno_answer {
100 unset ANSWER
101 while [ "$ANSWER" != 'yes' ] && [ "$ANSWER" != 'no' ]
102 do {
103 echo -n "$1"
104 read ANSWER
105 }
106 done
107}
108
109function conf_string_answer {
110 echo -n "$1"
111 read ANSWER
112}
113
Ove Kaaven2043ba01999-04-18 13:16:29 +0000114# startup...
115
Ove Kaaven2c767522000-10-29 18:02:53 +0000116echo "WINE Installer v0.5"
Ove Kaaven2043ba01999-04-18 13:16:29 +0000117echo
Ove Kaavene1858882000-04-08 20:20:21 +0000118
119if [ "$BINDIST" = 'no' ]
120then {
121
Ove Kaaven2043ba01999-04-18 13:16:29 +0000122if ! [ -f configure ]
123then {
124 echo "You're running this from the wrong directory."
Andreas Mohr8724ea82000-11-25 01:23:32 +0000125 echo "Change to the Wine source's main directory and try again."
Ove Kaaven2043ba01999-04-18 13:16:29 +0000126 exit 1
127}
128fi
129
Andreas Mohr8bba9ba2000-08-28 21:32:08 +0000130# check whether RPM installed, and if it is, remove any old wine rpm.
Ove Kaaven2c767522000-10-29 18:02:53 +0000131hash rpm &>/dev/null
132RET=$?
Andreas Mohr8bba9ba2000-08-28 21:32:08 +0000133if [ $RET -eq 0 ]; then
134 if [ -n "`rpm -qi wine 2>/dev/null|grep "^Name"`" ]; then
Ove Kaaven2c767522000-10-29 18:02:53 +0000135 echo "Warning: Old Wine RPM install detected. Do you want to remove it first?"
136 conf_yesno_answer "(yes/no) "
137 if [ "$ANSWER" = 'yes' ]; then
Andreas Mohr8bba9ba2000-08-28 21:32:08 +0000138 echo Starting wine rpm removal...
139 rpm -e wine; RET=$?
140 if [ $RET -eq 0 ]; then
141 echo Done.
142 else
Phil Colea7c48b12000-08-31 02:07:07 +0000143 echo "FAILED. Probably you aren't installing as root."
Andreas Mohr8724ea82000-11-25 01:23:32 +0000144 echo "Expect problems (library conflicts with existing install etc.)."
Andreas Mohr8bba9ba2000-08-28 21:32:08 +0000145 fi
146 else
147 echo "Sorry, I won't install Wine when an rpm version is still installed."
148 echo "(Wine support suffered from way too many conflicts)"
149 echo "Have a nice day !"
Ove Kaaven6e143b32000-10-31 00:59:01 +0000150 exit 1
Andreas Mohr8bba9ba2000-08-28 21:32:08 +0000151 fi
152 fi
153fi
154
Ove Kaaven2043ba01999-04-18 13:16:29 +0000155# run the configure script, if necessary
156
Ove Kaavence2b7242000-03-04 19:13:52 +0000157if [ -f config.cache ] && [ -f Makefile ] && [ Makefile -nt configure ]
Ove Kaaven2043ba01999-04-18 13:16:29 +0000158then {
159 echo "I see that WINE has already been configured, so I'll skip that."
Ove Kaavence2b7242000-03-04 19:13:52 +0000160 # load configure results
161 . ./config.cache
Ove Kaaven2043ba01999-04-18 13:16:29 +0000162}
163else {
Ove Kaaven2043ba01999-04-18 13:16:29 +0000164 echo "Running configure..."
165 echo
Ove Kaavene1858882000-04-08 20:20:21 +0000166 if ! ./configure $CONFARGS
Ove Kaaven2043ba01999-04-18 13:16:29 +0000167 then {
168 echo
169 echo "Configure failed, aborting install."
170 rm -f config.cache
171 exit 1
172 }
173 fi
Ove Kaavence2b7242000-03-04 19:13:52 +0000174 # load configure results
175 . ./config.cache
Ove Kaaven2043ba01999-04-18 13:16:29 +0000176 # make sure X was found
Ove Kaavence2b7242000-03-04 19:13:52 +0000177 eval "$ac_cv_have_x"
178 if [ "$have_x" != "yes" ]
Ove Kaaven2043ba01999-04-18 13:16:29 +0000179 then {
180 echo "Install the X development headers and try again."
181 rm -f config.cache
182 exit 1
183 }
Ove Kaavence2b7242000-03-04 19:13:52 +0000184 elif [ "$ac_cv_header_X11_xpm_h" != "yes" ]
Ove Kaavenb822b842000-02-25 20:51:09 +0000185 then {
186 echo "Install the Xpm development headers and try again."
187 rm -f config.cache
188 exit 1
189 }
Ove Kaaven2043ba01999-04-18 13:16:29 +0000190 fi
191}
192fi
193
194# now do the compilation
195
196if [ -f wine ] && [ wine -nt Makefile ]
197then {
198 echo "Hmm, looks like WINE is already compiled. I'll skip that too, I guess."
199}
200else {
Ove Kaaven6e143b32000-10-31 00:59:01 +0000201 echo "Compiling WINE. Grab a lunch or two, rent a video, or whatever,"
202 echo "in the meantime..."
Ove Kaaven2043ba01999-04-18 13:16:29 +0000203 echo
204 if ! { make depend && make; }
205 then {
206 echo
207 echo "Compilation failed, aborting install."
208 exit 1
209 }
210 fi
211 echo
212}
213fi
214
215# and installation, if root
216
217if [ `whoami` != 'root' ]
218then {
219 echo "You aren't root, so I'll skip the make install."
Ove Kaavene1858882000-04-08 20:20:21 +0000220 # setup to run from current directory
221 DLLPATH="$PWD/dlls"
222 if [ -z "$LD_LIBRARY_PATH" ]
223 then LD_LIBRARY_PATH="$PWD:$DLLPATH"
224 else LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$PWD:$DLLPATH"
225 fi
226 export LD_LIBRARY_PATH
Ove Kaaven91ae8cb2000-07-23 13:32:04 +0000227 DEBUGGER="$PWD/$HDEBUGGER"
Ove Kaavene1858882000-04-08 20:20:21 +0000228 echo
229 echo "NOTE! To run Wine without installing, you must set the environment variable"
230 echo "LD_LIBRARY_PATH to $PWD:$DLLPATH"
231 echo "in your logon scripts."
Ove Kaaven2043ba01999-04-18 13:16:29 +0000232}
233else {
234 echo "Now installing binaries onto the system..."
235 echo
236 if ! make install
237 then {
238 echo
239 echo "Installation failed, aborting."
240 exit 1
241 }
242 fi
Ove Kaavene1858882000-04-08 20:20:21 +0000243 if [ -f /etc/ld.so.conf ] && ! grep -qs "$libdir" /etc/ld.so.conf
Ove Kaavenb822b842000-02-25 20:51:09 +0000244 then {
245 echo
Ove Kaavene1858882000-04-08 20:20:21 +0000246 echo "$libdir didn't exist in your /etc/ld.so.conf, adding it now..."
247 echo "$libdir" >>/etc/ld.so.conf
Ove Kaavenb822b842000-02-25 20:51:09 +0000248 echo "Re-running ldconfig..."
Ove Kaavence2b7242000-03-04 19:13:52 +0000249 eval "$ac_cv_path_LDCONFIG"
Ove Kaavenb822b842000-02-25 20:51:09 +0000250 }
251 fi
Ove Kaaven2043ba01999-04-18 13:16:29 +0000252}
253fi
Ove Kaaven2043ba01999-04-18 13:16:29 +0000254
Ove Kaavene1858882000-04-08 20:20:21 +0000255}
256fi # BINDIST
257
Ove Kaaven2043ba01999-04-18 13:16:29 +0000258# now check whether we should generate wine.conf
259if [ -z "$DOCONF" ]
260then DOCONF=auto
261fi
262
263if [ "$DOCONF" = 'auto' ]
264then {
265 # see if we already have a system wine.conf
Ove Kaavene1858882000-04-08 20:20:21 +0000266 if [ -f $CONF ]
Ove Kaaven2043ba01999-04-18 13:16:29 +0000267 then DOCONF=no
268 fi
269}
270fi
271
272if [ "$DOCONF" != 'no' ]
273then {
274 if [ `whoami` != 'root' ]
275 then {
276 CONF=~/.winerc
277 if ! [ -f $CONF ]
278 then {
279 if [ "$DOCONF" != 'yes' ]
280 then {
Ove Kaaven2c767522000-10-29 18:02:53 +0000281 conf_question medium make_user_winerc \
282 "Since you aren't root, and there's no system wine.conf, I assume" \
283 "you want a user-specific .winerc. Am I correct?"
284 conf_yesno_answer "(yes/no) "
285 DOCONF="$ANSWER"
Ove Kaaven2043ba01999-04-18 13:16:29 +0000286 }
287 fi
288 if [ "$DOCONF" = 'no' ]
Ove Kaavene1858882000-04-08 20:20:21 +0000289 then {
Ove Kaaven2c767522000-10-29 18:02:53 +0000290 conf_question high need_root \
291 "Aborting install. Try again as root to generate a system wine.conf."
Ove Kaavene1858882000-04-08 20:20:21 +0000292 exit 1
293 }
Ove Kaaven2043ba01999-04-18 13:16:29 +0000294 fi
Ove Kaavene1858882000-04-08 20:20:21 +0000295 echo
Ove Kaaven2043ba01999-04-18 13:16:29 +0000296 }
297 fi
298 }
299 else {
Joerg Mayerd178fb01999-08-04 14:26:08 +0000300 mkdir -p $sysconfdir
Ove Kaaven2043ba01999-04-18 13:16:29 +0000301 DOCONF=yes
302 }
303 fi
304}
305fi
306
Ove Kaavene1858882000-04-08 20:20:21 +0000307# generate wine.conf from existing windows install, if any
Ove Kaaven2043ba01999-04-18 13:16:29 +0000308if [ "$DOCONF" = 'yes' ]
309then {
Ove Kaavene1858882000-04-08 20:20:21 +0000310 if [ "$DOWCHK" = 'yes' ] || [ "$DOWCHK" = 'auto' ]
311 then {
Ove Kaaven2c767522000-10-29 18:02:53 +0000312 echo
313 echo -n "Searching for an existing Windows installation..."
Ove Kaaven6e143b32000-10-31 00:59:01 +0000314 if ! $WINECONF -inifile "$WINEINI" > $CONF 2>/dev/null
Ove Kaavene1858882000-04-08 20:20:21 +0000315 then {
316 rm -f $CONF
Ove Kaaven2c767522000-10-29 18:02:53 +0000317 echo " not found."
318 conf_question low do_without_windows \
Ove Kaaven6e143b32000-10-31 00:59:01 +0000319 "Windows was not found on your system, so I assume you want" \
320 "a Wine-only installation. Am I correct?"
Ove Kaaven2c767522000-10-29 18:02:53 +0000321 conf_yesno_answer "(yes/no) "
322 if [ "$ANSWER" = 'no' ]
Ove Kaavene1858882000-04-08 20:20:21 +0000323 then {
Ove Kaaven2c767522000-10-29 18:02:53 +0000324 conf_question high windows_not_found \
325 "Aborting install. Make sure your Windows partition is mounted and try again," \
326 "or create $CONF manually by copying from $WINEINI and adapting the drive paths."
Ove Kaavene1858882000-04-08 20:20:21 +0000327 exit 1
328 }
329 fi
Ove Kaaven2c767522000-10-29 18:02:53 +0000330 DOWINE=yes
Ove Kaavene1858882000-04-08 20:20:21 +0000331 }
332 else {
Ove Kaaven2c767522000-10-29 18:02:53 +0000333 echo " found."
Ove Kaaven6e143b32000-10-31 00:59:01 +0000334 conf_reset_question windows_found
Ove Kaaven2c767522000-10-29 18:02:53 +0000335 conf_question low windows_found \
336 "Created $CONF using your existing Windows installation." \
337 "You probably want to review the file, though."
Ove Kaavene1858882000-04-08 20:20:21 +0000338 DOWINE=no
339 }
340 fi
Ove Kaavene1858882000-04-08 20:20:21 +0000341 }
342 elif [ "$DOWINE" = 'auto' ]
343 then DOWINE=yes
344 fi
345}
346elif [ "$DOWINE" = 'auto' ]
347then DOWINE=no
348fi
349
Ove Kaavenb5d37ec2000-04-15 20:37:14 +0000350# setup a no-windows installation, if necessary
Ove Kaavene1858882000-04-08 20:20:21 +0000351if [ "$DOWINE" = 'yes' ]
352then {
353 if [ `whoami` != 'root' ]
354 then DCROOT=~/c
355 else DCROOT=/c
356 fi
Ove Kaaven2c767522000-10-29 18:02:53 +0000357 conf_question low drivec_path \
Ove Kaaven6e143b32000-10-31 00:59:01 +0000358 "Configuring Wine without Windows." \
359 "Some fake Windows directories must be created, to hold any .ini files, DLLs," \
360 "start menu entries, and other things your applications may need to install." \
361 "Where would oyu like your fake C drive to be placed?"
Ove Kaavene1858882000-04-08 20:20:21 +0000362 while [ -z "$CROOT" ]
363 do {
Ove Kaaven6e143b32000-10-31 00:59:01 +0000364 conf_string_answer "(default is $DCROOT) "
Ove Kaaven2c767522000-10-29 18:02:53 +0000365 if [ -z "$ANSWER" ]
Ove Kaavene1858882000-04-08 20:20:21 +0000366 then CROOT="$DCROOT"
Ove Kaaven6e143b32000-10-31 00:59:01 +0000367 elif ! [ -d "$ANSWER" ]
Ove Kaavene1858882000-04-08 20:20:21 +0000368 then {
Ove Kaaven2c767522000-10-29 18:02:53 +0000369 if mkdir -p "$ANSWER"
370 then CROOT="$ANSWER"
Ove Kaaven6e143b32000-10-31 00:59:01 +0000371 else conf_reset_question drivec_path
Ove Kaavene1858882000-04-08 20:20:21 +0000372 fi
373 }
Ove Kaaven6e143b32000-10-31 00:59:01 +0000374 else CROOT="$ANSWER"
Ove Kaavene1858882000-04-08 20:20:21 +0000375 fi
376 }
377 done
378 echo "Configuring Wine for a no-windows install in $CROOT..."
Ove Kaaven6e143b32000-10-31 00:59:01 +0000379 for tdir in "$CROOT/windows" "$CROOT/windows/system" \
380 "$CROOT/windows/Start Menu" "$CROOT/windows/Start Menu/Programs" \
381 "$CROOT/Common Files" "$CROOT/Program Files" \
382 "$CROOT/windows/Profiles" "$CROOT/windows/Profiles/Administrator"
Ove Kaavene1858882000-04-08 20:20:21 +0000383 do [ -d "$tdir" ] || mkdir "$tdir"
384 done
385 [ -f "$CROOT/windows/win.ini" ] || cp "$WININI" "$CROOT/windows/win.ini"
386 [ -f "$CROOT/windows/system.ini" ] || cp "$SYSTEMINI" "$CROOT/windows/system.ini"
387 if [ "$DOCONF" = 'yes' ]
388 then {
Ove Kaaven91ae8cb2000-07-23 13:32:04 +0000389 sed "s|Path=/c\$|Path=${CROOT}|" $WINEINI > $CONF
Ove Kaaven6e143b32000-10-31 00:59:01 +0000390 conf_reset_question default_config
Ove Kaaven2c767522000-10-29 18:02:53 +0000391 conf_question low default_config \
392 "Created $CONF using default Wine configuration." \
393 "You probably want to review the file, though."
Ove Kaavene1858882000-04-08 20:20:21 +0000394 }
395 fi
Ove Kaaven91ae8cb2000-07-23 13:32:04 +0000396 # now we really should install the registry
397 if [ "$DOREG" = 'auto' ]
398 then DOREG=yes
399 fi
Ove Kaavene1858882000-04-08 20:20:21 +0000400}
401elif [ -z "$CROOT" ]
402then {
Ove Kaaven2c767522000-10-29 18:02:53 +0000403 echo
Ove Kaavene1858882000-04-08 20:20:21 +0000404 echo "Reading current Wine configuration from $CONF..."
405 CROOT=`sed -n '/^\[Drive C\]$/,/^\[.*\]$/ s/^Path=\(.*\)/\1/p' $CONF`
406 echo "Drive C is configured at $CROOT."
Ove Kaaven2043ba01999-04-18 13:16:29 +0000407}
408fi
409echo
410
Ove Kaavene1858882000-04-08 20:20:21 +0000411# fixup EXTRA_LD_LIBRARY_PATH
412if [ "$DOCONF" = 'yes' ]
413then {
414 echo "Setting EXTRA_LD_LIBRARY_PATH in .winerc to $DLLPATH..."
Ove Kaaven91ae8cb2000-07-23 13:32:04 +0000415 sed "s|EXTRA_LD_LIBRARY_PATH=.*|EXTRA_LD_LIBRARY_PATH=${DLLPATH}|" $CONF > $CONF.new
Ove Kaavene1858882000-04-08 20:20:21 +0000416 mv -f $CONF.new $CONF
417 echo
418}
419fi
420
421# check whether we need to install default registry
422# (not to be done if windows registry exists)
423if [ "$DOREG" = 'auto' ]
424then {
425 echo "Checking for real Windows registry..."
426 if [ -f "$CROOT/windows/system.dat" ]
427 then DOREG=no
428 elif [ -f "$CROOT/windows/system32/config/system" ]
429 then DOREG=no
430 else DOREG=yes
431 fi
432 if [ "$DOREG" = 'yes' ]
433 then echo "Not found, default Wine registry will be installed."
434 else echo "Windows registry found, will not install default Wine registry."
435 fi
436 echo
437}
438fi
439
Ove Kaaven2043ba01999-04-18 13:16:29 +0000440# install default registry entries
441if [ "$DOREG" = 'yes' ]
442then {
Ove Kaavene1858882000-04-08 20:20:21 +0000443 if [ "$BINDIST" = 'no' ]
444 then {
445 echo "Compiling regapi..."
446 echo
447 (cd programs/regapi; make)
448 echo
449 }
450 fi
Ove Kaavenf561aad2000-05-09 22:32:42 +0000451 echo "Preparing to install default Wine registry entries..."
452
453 # create a temporary wineinstall.conf file using ttydrv,
454 # so that we don't have to run regapi under X
455 sed "s/GraphicsDriver=.*/GraphicsDriver=ttydrv/" $CONF > $TMPCONF
456
457 # create a temporary wineinstall.reg with fixed debugger path
Ove Kaaven2c767522000-10-29 18:02:53 +0000458 $DEFCAT $DEFREG | sed "s|debugger/winedbg|${DEBUGGER}|" > $TMPREG
Ove Kaavenf561aad2000-05-09 22:32:42 +0000459
Ove Kaavene1858882000-04-08 20:20:21 +0000460 echo "Installing default Wine registry entries..."
Ove Kaaven2043ba01999-04-18 13:16:29 +0000461 echo
Ove Kaavenf561aad2000-05-09 22:32:42 +0000462 if ! $REGAPI --config $TMPCONF setValue < $TMPREG > /dev/null
Ove Kaaven2043ba01999-04-18 13:16:29 +0000463 then {
Ove Kaavenf561aad2000-05-09 22:32:42 +0000464 rm -f $TMPCONF $TMPREG
Ove Kaavenf561aad2000-05-09 22:32:42 +0000465 echo "Registry install failed."
Ove Kaaven6e143b32000-10-31 00:59:01 +0000466 conf_reset_question regapi_error
Ove Kaaven2c767522000-10-29 18:02:53 +0000467 conf_question high regapi_error
Ove Kaavenb822b842000-02-25 20:51:09 +0000468 exit 1
Ove Kaaven2043ba01999-04-18 13:16:29 +0000469 }
Ove Kaavenb5d37ec2000-04-15 20:37:14 +0000470 else echo "Registry entries successfully installed."
Ove Kaaven2043ba01999-04-18 13:16:29 +0000471 fi
Ove Kaavenf561aad2000-05-09 22:32:42 +0000472 rm -f $TMPCONF $TMPREG
Ove Kaavenb5d37ec2000-04-15 20:37:14 +0000473 if [ "$SYSREG" = 'auto' ]
474 then SYSREG=yes
475 fi
Ove Kaaven2043ba01999-04-18 13:16:29 +0000476}
477fi
Ove Kaavenb5d37ec2000-04-15 20:37:14 +0000478
479# make root's registry global, if desired
480if [ `whoami` = 'root' ] && [ "$SYSREG" = 'yes' ]
481then {
Ove Kaaven91ae8cb2000-07-23 13:32:04 +0000482 [ -d ~/.wine ] || mkdir ~/.wine
Ove Kaavenb5d37ec2000-04-15 20:37:14 +0000483 if ! [ -f $sysconfdir/wine.userreg ]
484 then {
485 echo "Linking root's user registry hive to the global registry..."
Ove Kaaven6e143b32000-10-31 00:59:01 +0000486 [ -f ~/.wine/wine.userreg ] && cp ~/.wine/wine.userreg $sysconfdir/wine.userreg
Ove Kaavenb5d37ec2000-04-15 20:37:14 +0000487 ln -sf $sysconfdir/wine.userreg ~/.wine/wine.userreg
488 }
489 fi
490 if ! [ -f $sysconfdir/wine.systemreg ]
491 then {
492 echo "Linking root's system registry hive to the global registry..."
Ove Kaaven6e143b32000-10-31 00:59:01 +0000493 [ -f ~/.wine/system.reg ] && cp ~/.wine/system.reg $sysconfdir/wine.systemreg
Ove Kaavenb5d37ec2000-04-15 20:37:14 +0000494 ln -sf $sysconfdir/wine.systemreg ~/.wine/system.reg
495 }
496 fi
497}
498fi
499
500# it's a wrap
Ove Kaaven2043ba01999-04-18 13:16:29 +0000501echo
502echo "Installation complete for now. Good luck (this is still alpha software)."
Ove Kaavene1858882000-04-08 20:20:21 +0000503echo "If you have problems with WINE, please read the documentation first,"
504echo "as many kinds of potential problems are explained there."
Ove Kaaven6e143b32000-10-31 00:59:01 +0000505
506exit 0